; Autor : Jess Manuel Hernndez
; Fecha : Octubre 1997 / Sept 1999
;
; Descripcin :
;
; Controla el tiempo de ejecucin contando el nmero de ciclos de
;  reloj empleados para realizar una determinada accin. Lo imprime
;  en pantalla siempre que estemos en un modo VGA ( no VESA )
;
[BITS 16]

[SEGMENT CODE] ;-----------------------------------------------------------
[GLOBAL StartTimer] ;======================================================
StartTimer:
       push ds
       push eax
       push edx                     ; Guarda los registros a usar
       mov ax,_DATA
       mov ds,ax                    ; Desactivo el bit CR4.TSD
                                    ; (TimeStamp Disable) para poderlo usar
       mov eax,cr4
       and eax,0fffffffbh           ; TSD es el bit 2 de CR4
       mov cr4,eax
       rdtsc                        ; Halla el nmero de ciclos de reloj
                                    ; desde el ltimo reset => EDX:EAX
                                    ; Guarda el tiempo en ciclos de reloj
       mov dword [ds:CLOCKS],eax
       mov dword [ds:CLOCKS+4],edx
       pop edx
       pop eax
       pop ds                       ; Recupera los registros
       retf

; Subrutina que cierra la marca de tiempo y halla la diferencia
[GLOBAL StopTimer] ;=======================================================
StopTimer:
       push ds
       push es
       pushad
       rdtsc
       mov bx,_DATA
       mov ds,bx
       mov es,bx
       sub eax,dword [ds:CLOCKS]
       sbb edx,dword [ds:CLOCKS+4]  ; Hallo la diferencia
       mov dword [ds:CLOCKS],eax
       mov dword [ds:CLOCKS+4],edx  ; Almacena el resultado
       and edx,edx
       mov al,' '
       mov cx,15
       std
       mov di,TNUM - 1
       rep stosb                    ; Borro el ltimo resultado
       mov si,0	                    ; Cuenta miles
       mov ebx,10
       mov eax,dword [DS:CLOCKS]    ; Tomo la parte baja
       mov di,TNUM - 1
DIG2:  xor edx,edx                  ; Slo una palabra
       div ebx
       add dl,30H                   ; Obtengo el digito
       mov [es:di],dl               ; Lo guardo
       dec di
       push eax
       and eax,eax                  ; Si es el ltimo digito no pinto punto
       jz Val1
       inc si
       mov dl,3                     ; Si es un digito multiplo de 3
       mov ax,si                    ;  pinto un punto decimal
       div dl
       and ah,ah
       jnz Val1
       mov byte [es:di],'.'
       dec di
Val1:  pop eax
       and eax,eax                  ; Compruebo si he terminado
       jnz DIG2                     ; Convierto el nmero a caracteres
       mov bp,TCAD                  ; Comienzo de la cadena a imprimir
       mov ax,1301h                 ; Servicio seleccionado: Imprime cadena
       mov bx,15
       mov dx,0B08H                 ; Posicin Y, Posicin X
       mov cx,TNUM-TCAD-3           ; Longitud en caracteres
       int 10h                      ; Imprimo la cadena resultado
       mov bp,TCAD
       add bp,23
       mov ax,1301H
       mov bx,14
       mov dx,0B1FH
       mov cx,3
       int 10h                      ; Imprimo la cadena resultado
@Sal:  popad
       pop es
       pop ds
       retf

[GLOBAL PrintFPS] ;========================================================
PrintFPS:
        ; EAX = MHz del microprocesador * Nmero de frames
       push ds
       push es
       pushad
       mov cx,_DATA
       mov ds,cx
       mov es,cx

        ; FPS = N_FRAMES * MHZ / CLOCKS
       mov dword [ds:NMHZ],eax
       finit
       fild dword [ds:NMHZ]           ; NMHZ
       fild dword [ds:MILLON]
       fmul st1
       fild qword [ds:CLOCKS]         ; NMHZ, CLK_LOW
       fdivr st1
       fistp dword [ds:CLOCKS]

       mov al,' '
       MOV CX,10
       STD
       MOV DI,FPSEND - 4
       REP STOSB                      ; Borro el ltimo resultado
       mov si,0		              ; Cuenta miles
       MOV EBX,10
       MOV EAX,DWORD [DS:CLOCKS]      ; Tomo la parte baja
       MOV DI,FPSEND - 5
DIG3:  XOR EDX,EDX                    ; Slo una palabra
       DIV EBX
       ADD DL,30H                     ; Obtengo el digito
       MOV [ES:DI],DL                 ; Lo guardo
       DEC DI
       push eax
       and eax,eax                    ; Si es el ltimo digito no pinto punto
       jz Val2
       inc si
       mov dl,3                       ; Si es un digito multiplo de 3
       mov ax,si                      ;  pinto un punto decimal
       div dl
       and ah,ah
       jnz Val2
       mov byte [es:di],'.'
       dec di
Val2:  pop eax
       AND EAX,EAX                    ; Compruebo si he terminado
       JNZ DIG3                       ; Convierto el nmero a caracteres
       MOV BP,FPS                     ; Comienzo de la cadena a imprimir
       MOV AX,1301H                   ; Servicio seleccionado: Imprime cadena
       mov bx,15
       MOV DX,0C03H                   ; Posicin Y, Posicin X
       MOV CX,FPSEND-FPS              ; Longitud en caracteres
       INT 10H                        ; Imprimo la cadena resultado
@Sal1: popad
       pop es
       pop ds
       retf

; Segmento de DATOS -------------------------------------------------------
[SEGMENT _DATA CLASS=DATA] 

TCAD   DB 'Clocks :                  '
TNUM   DB 0
FPS    DB 'Performance :             fps'
FPSEND DB 0
Error  DB 'Clocks : Medida incorrecta'
EFIN   DB 0
CLOCKS DD 0                ; Almacenar el nmero de ciclos de reloj
       DD 0
NMHZ   DD 0
MILLON DD 1000000

