[BITS 16]
; INCLUDELIB CAPTURA.LIB
[EXTERN _OpenZoran]
[EXTERN _Config]
[EXTERN _Capture]
[EXTERN _CloseZoran]

BytesPerScanLine equ 16
BitsPerPixel     equ 25

[SEGMENT CODE]
; Pone el video a funcionar en modo 800x600x32 bpp
; La captura ser
;       AH = 3  Continuamente
;       AH = 2  Captura asncrona
;       AH = 1  Captura sncrona
;       AH = 0  Para la captura
;
;       AL = 1  Entrada de video 1
;       AL = 2  Entrada de video 2
;
;       BX = Ancho
;       DX = Alto
;
;       CX = Modo Video VESA LFB
;
;       EDI = Destino LFB
[GLOBAL Video]
Video:
        push cx
        mov	cx,_DATA
 	mov	ds,cx                ; Apunta al segmento de datos
        mov     es,cx
        mov     [Vid1],al            ; Entrada de video (=1,2)
        shr     ax,8
        mov     [Grab1],ax           ; Tipo captura
        mov     [Destino],edi        ; Guarda parmetros
        mov     [Ancho],bx
        mov     [Alto],dx
        pop cx
        mov di,DatosVESA             ; ES:DI = ModeInfoBlock structure
        mov ax,4f01h                 ; AX    = 4F01h
        int 10h                      ; CX    = Mode number
        cmp ax,004fh
        je  .Sigue
        jmp FIN                      ; Si error salgo
.Sigue:
        xor ebx,ebx
        mov bl,[DatosVESA+BitsPerPixel]
        shr ebx,3                    ; Divido entre 8
        mov [BPP__],ebx
        cmp ebx,4
        jne NoEs32BPP
        mov byte [Prof],7            ; Modo RGB8888 (32 bpp)
        jmp Sigue
NoEs32BPP:
        cmp ebx,3
        jne FIN
        mov byte [Prof],1            ; Modo RGB888  (24 bpp)

Sigue:  xor eax,eax
        mov ax,[DatosVESA+BytesPerScanLine]
        xor dx,dx
        idiv bx                      ; En EAX = Ancho Pantalla
        sub ax,[Ancho]
        mov ebx,[BPP__]
        imul eax,ebx
        mov [Inter],ax               ; Inter=(AnchoPant-AnchoVent)*BPP

        call    far _OpenZoran       ; Existe el dispositivo?
	cmp	ax,0
	jne	FIN

        push    dword [C1+18]
        push    word  [C1+14]
        push    word  [C1+12]
        push    word  [C1+10]
        push    word  [C1+8]
        push    word  [C1+6]
        push    word  [C1+4]
        push    word  [C1+2]
        push    word  [C1]
        call    far _Config          ; Configura la captura
        add     sp,20
	cmp	ax,0
	jne	FIN

        mov ax,[Grab1]               ; ModoCaptura (=0) STOP,
                                     ;             (=1) 1 FRAME SINCRONO,
                                     ;             (=2) 1 FRAME ASINCRONO,
                                     ;             (=3) CONTINUO
        push ax
        push    dword [Destino]      ; Direccin lineal (LFB)
        call    far _Capture         ; Inicia la Captura de Video
	add	sp,6
FIN:    retf

; -------------------------------------------------------------------------
[GLOBAL CierraVideo]
CierraVideo:
        mov	cx,_DATA
 	mov	ds,cx                ; Apunta al segmento de datos
        call    far _CloseZoran
        retf

; Segmento de DATOS -------------------------------------------------------
[SEGMENT _DATA CLASS=DATA]
Destino dd      0e000000h        ; Dir LFB
Grab1   resw      1
BPP__   resd      1

Ancho   dw      200     ; Ancho ventana video (Max = 756)
C1 equ Ancho
Alto    dw      576     ; Alto ventana video (Max = 576)
Prof    db      7       ; Profundidad RGB888=1, RGB8888=7
Inter   dw      (800-200)*4    ; Interlineado (AnchoTot-AnchoVent)*BPP
        db      210     ; Brillo
        db      102     ; Contraste
        db      15      ; Color
        db      127     ; Saturacion
        db      244     ; Ganancia UV
        db      3       ; Escalado = {0 NE,1 EH,2 EV,3 EHyV}
Vid1    db      1       ; Entrada de video
        db      1       ; Estandar PAL=1
        dd      0       ; Overlay
        dd      0       ; -------------

DatosVESA  RESB  256 ;ModeInfoBlock {?}
