#ifndef _DRIVER

#define TRUE 1
#define FALSE 0

typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;
typedef unsigned char byte;
typedef unsigned int word;
typedef unsigned long dword;
typedef unsigned char BOOL;

#include <stdlib.h>
#include <mem.h>
#include "asr.h"
#include "csr.h"

#define _DRIVER _DRIVER

extern uint CambiarLimiteDS(void);
extern uint RestablecerLimiteDS(void);
extern ulong LeerDW(ulong);
extern void EscribirDW(ulong, ulong);
extern void uDelay(void);
extern uint ExistePCIBIOS(void);
extern uint BuscarDisp(uint, uint, uint*);
extern uint LeerPCIDW(uint, uint, ulong*);
extern uint EscribirPCIDW(uint, uint, ulong);
extern uint LeerPCIB(uint, uint, uchar*);
extern uint EscribirPCIB(uint, uint, uchar);



struct ZORAN
	{
	word		BusDevFun;
	BOOL		bOpen;
	byte		Command;
	dword		DirBase;
	int		CapPixelBytes;
	int		CapScanLineSize;
	int		InterCampo;
	};

struct PARAM_MODIF {
	word Ancho;
	word Alto;
	byte Profundidad;
	word InterLineado;
	byte Brillo;
	char Contraste;
	char Color;
	char Saturacion;
	byte GananciaUV;
	byte Escalado;
	byte VidIn;
	byte Estandar;
	dword Overlay;
	};

extern struct ZORAN Zoran;
extern struct ZR36120 Zr36120;


// ZORAN

#define YUV422	0
#define RGB888	1
#define RGB565	2
#define RGB555	3
#define BGR888	4
#define BGR565	5
#define BGR555	6
#define RGB8888	7

#define NTSC 0
#define PAL 1
#define SECAM 2


#define STOP	0
#define GRAB_SIN	1
#define GRAB_ASIN	2
#define CONTINUO	3

// I2CBus
extern int	I2CWrite(int I2CAdr,int I2CSubAdr,const char * TabByte,int NbMaxByte);

// SAA7110
#define SAA7110W	0x9c
#define SAA7110R	0x9d

#define BRILLO_ADR	0x19
#define CONTRASTE_ADR	0x13
#define COLOR_ADR		0x07
#define SATURACION_ADR	0x12
#define GANANCIAUV_ADR	0x11


#endif