	DOSSEG
	.MODEL LARGE

	.DATA
; Tabla de descriptores globales con limite para DS de 4 Gb
GDT	db 	0,0,0,0,0,0,0,0			; Descriptor NULO
	db 	0ffh,0ffh,00h,00h,00h,92h,8fh,00h	; DS -> Limite 4Gb

PGDT	dw 	16	; Tamao de la GDT
	dd 	0	; Contendra la direccion a la GDT

; Tabla de descriptores globales con limite para DS de 64 Kb
GDT2	db 	0,0,0,0,0,0,0,0			; Descriptor NULO
	db 	10h,00h,00h,00h,00h,92h,80h,00h	; DS -> Limite 64Kb


	.CODE
	PUBLIC   _CambiarLimiteDS, _RestablecerLimiteDS
_CambiarLimiteDS PROC FAR
	.386p
	; Detectar presencia de EMM386 o QEMM
	pusha
	push	ds
	mov	eax, cr0
	ror	eax,1
	jc		EMM
	; Cargar DGTR apuntando a GDT
	mov	ax,@data
	mov	ds,ax
	xor	ebx,ebx
	mov	ax, SEG GDT
	mov	bx, OFFSET GDT
	mov	ecx,16
	mul	ecx
	add	ebx,eax
	mov	dword ptr PGDT+2,ebx
	lgdt	pword ptr PGDT
	; Pasar a Modo Protegido
	mov	eax,CR0
	or	eax,1		; Activar bit 0 de CR0
	mov	CR0,eax
	; Estamos en Modo Protegido
	jmp	INICIO_MP	; Salto para vaciar cola de instrucciones

INICIO_MP:
	mov	bx,8
	mov	ds,bx	; Selector(DS) apunta a la entrada 1 de GDT
	; Pasar a Modo Real
	mov	eax,CR0
	and	eax,0FEh	; Desactivar bit 0 de CR0
	mov	CR0,eax
	jmp	VOLVER_MR

	; Salir por gestor de memoria cargado
EMM:
	pop	ds
	popa
	mov	ax,1		;Sale con error
	retf

VOLVER_MR:
	pop	ds
	popa
	xor	ax,ax		;Sin Errores
	retf
_CambiarLimiteDS ENDP


_RestablecerLimiteDS PROC FAR
	; Detectar presencia de EMM386 o QEMM
	pusha
	push	ds
	mov	eax, cr0
	ror	eax,1
	jc		EMM2
	; Cargar DGTR apuntando a GDT
	mov	ax,@data
	mov	ds,ax
	xor	ebx,ebx
	mov	ax, SEG GDT2
	mov	bx, OFFSET GDT2
	mov	ecx,16
	mul	ecx
	add	ebx,eax
	mov	dword ptr PGDT+2,ebx
	lgdt	pword ptr PGDT
	; Pasar a Modo Protegido
	mov	eax,CR0
	or	eax,1		; Activar bit 0 de CR0
	mov	CR0,eax
	; Estamos en Modo Protegido
	jmp	INICIO_MP2	; Salto para vaciar cola de instrucciones

INICIO_MP2:
	mov	bx,8
	mov	ds,bx	; Selector(DS) apunta a la entrada 1 de GDT
	; Pasar a Modo Real
	mov	eax,CR0
	and	eax,0FEh	; Desactivar bit 0 de CR0
	mov	CR0,eax
	jmp	VOLVER_MR2

	; Salir por gestor de memoria cargado
EMM2:
	pop	ds
	popa
	mov	ax,1		;Sale con error
	retf

VOLVER_MR2:
	pop	ds
	popa
	xor	ax,ax		;Sin Errores
	retf
_RestablecerLimiteDS ENDP
	END